import json

from scapy.all import *

# Bin data
dns_templet_bin = b'\xe0\x1a\x01\x10\x00\x01\x00\x00\x00\x00\x00\x01\ncreviewstv\x02cf\x00\x00/\x00\x01\x00\x00)\x02\x00\x00\x00\x80\x00\x00\x1c\x00\n\x00\x18\x07\x14\x8c\x8d\x88\xae\xab\xc8\x91<?\x8f^y\xdd\xbb#\x1f\x0f\x17\xbc\x01\xa9D'
cookie2 = b"\x2a\xed\x6a\x88\xdf\xc8\xf6\x3d\x95\x52\x66\x5f\x5e\x7a\x0c\x96\xee\x35\x58\x73\xa6\x95\x09\xef"
cookie3 = b"\x25\x6d\xa9\xb8\xe3\x05\xbc\xc7\xa3\x7c\x67\xaa\x5e\x79\xf8\xb2\x48\x3b\xfb\xe5\x2f\x04\xbe\xc6"
cookie4 = b"\x43\x1b\x8c\x4a\x73\xfa\x19\x86\x3e\xc7\x12\xce\x5e\x79\xee\x31\x75\x57\xa6\x8e\x67\x5f\x56\x04"

# dns templet
dns_templet = DNS(dns_templet_bin)
dns_templet.id = RandShort()


def change_cookie(cookie):
    rdata = dns_templet.ar.rdata[0].copy()
    rdata.optdata = cookie
    new_dns_templet = dns_templet.copy()
    new_dns_templet.ar.rdata = [rdata]
    return new_dns_templet


# Generate send packages list
with open('domain_list_3.json', 'r') as f:
    domain_list_3 = json.load(f)


def gen_send_pkgs_list(domain_list, dns_templet, qtype=None):
    pkgs = []
    for domain in domain_list:
        dns_layer = dns_templet.copy()
        dns_layer.qd.qname = domain
        if qtype:
            dns_layer.qd.qtype = qtype
        pkg = IP(dst='127.0.0.1') / UDP(sport=RandShort(), dport=12353) / dns_layer
        pkgs.append(pkg)
    return pkgs


# Send packages
conf.L3socket = L3RawSocket


def send_pkgs(domain_list, inter=0, cookie=None, qtype=None):
    if cookie:
        _dns_templet = change_cookie(cookie)
    else:
        _dns_templet = dns_templet

    pkgs = gen_send_pkgs_list(domain_list, _dns_templet, qtype)
    send(pkgs, inter)

# print('Qtype: NSEC')
# send_pkgs(domain_list_3, inter=0.1)
# send_pkgs(domain_list_3, cookie=cookie2, inter=0.01)
# send_pkgs(domain_list_3, cookie=cookie3, inter=0.001)
# send_pkgs(domain_list_3, cookie=cookie4, inter=0)
#
# print('Qtype: A')
# send_pkgs(domain_list_3, inter=0.1, qtype='A')
# send_pkgs(domain_list_3, cookie=cookie2, inter=0.01, qtype='A')
# send_pkgs(domain_list_3, cookie=cookie3, inter=0.001, qtype='A')
# send_pkgs(domain_list_3, cookie=cookie4, inter=0, qtype='A')

# send_pkgs(domain_list_3, inter=0)
# send_pkgs(domain_list_3, cookie=cookie2, inter=0, qtype='AAAA')
# send_pkgs(domain_list_3, cookie=cookie3, inter=0, qtype='A')
# send_pkgs(domain_list_3, cookie=cookie4, inter=0, qtype='SOA')
